// Type definitions for ssdeep.js 0.0
// Project: https://github.com/cloudtracer/ssdeep.js
// Definitions by: JPBM135 <https://github.com/JPBM135>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped

export type Hash = string;

/**
 * Returns a hash of the given string.
 * @param data Any string
 */
export function digest(data: string): Hash;

/**
 * Compares two hashes previously generated by ssdeep.digest().
 * @param d1 The first hash to compare
 * @param d2 The second hash to compare
 * @returns The similarity of the two hashes (A number between 0 and 100)
 */
export function similarity(d1: Hash, d2: Hash): number;

export as namespace ssdeep;
